	device zxspectrum128
        ORG #6000
begin
; - 
	ld hl,$5800,de,$5801,bc,767,(hl),$48+6:ldir
 
; 	call beepor
; 
empty=$BE00
	ld hl,empty,de,empty+1,bc,512,(hl),0:ldir

	call ib
	call drawboard

	call drawk
	
	call drawscore

;0-empty
;1-black
;2-white
;black:
;	ld hl,bspr,de,$4000+5+1*32:call puts ; 0
;	ld hl,wspr,de,$4000+5+1*32+8:call puts ; 1
;
;	ld hl,wspr,de,$5000+5+1*32:call puts ;0
;	ld hl,bspr,de,$5000+5+1*32+8:call puts ; 1
;
;	jr $
;	ld a,ccol,(cc),a
	ld de,0
	call crsxy
;keyboard
kboard:
	call wk
 ld de,(cxy)
 ld a,$F7:in a,(#FE):and 16:jp z,left;5 is left
;O
 ld a,$DF:in a,(#FE):and 2:jp z,left

 ld a,$EF:in a,(#FE):and 4:jp z,right;8 is right
;P
 ld a,$DF:in a,(#FE):and 1:jp z,right

 ld a,$EF:in a,(#FE):and 8:jp z,up;7 is up
;Q
 ld a,$FB:in a,(#FE):and 1:jp z,up

 ld a,$EF:in a,(#FE):and 16:jp z,down;6 is down
;A
 ld a,$FD:in a,(#FE):and 1:jp z,down

; Fire
;0
	ld a,$EF:in a,($FE):and 1:jp z,fire
;En
	ld a,$BF:in a,($FE):and 1:jp z,fire
;Sp
	ld a,$7F:in a,($FE):and 1:jp z,fire
;M
	ld a,$7F:in a,($FE):and 4:jp z,fire

	jp kboard
endkey:
	call wp
	ei:halt
	push de
	call drawboard
	pop de
	ld (cxy),de
	call crsxy
	jp kboard

left:
	ld a,e
	or a
	jp z,kboard
	dec e
	jp endkey
right:
	ld a,e
	cp 2
	jp z,kboard
	inc e
	jp endkey
up:
	ld a,d
	or a
	jp z,kboard
	dec d
	jp endkey
down:
	ld a,d
	cp 2
	jp z,kboard
	inc d
	jp endkey

fire:
;what on cursor?
;	jr $
	call wp

	call mapxy
	ld a,(hl)
	or a:jp z,kboard
	cp 1:jp z,markp
	cp 2:jp z,markp
;3 valid move
	
	call r3b

	push de
	ld de,(sxy)
	call mapxy
	ld a,(hl)
	ld (hl),0
	pop de
	push af
	call mapxy
	pop af
	ld (hl),a
	ei:halt
	call drawboard
	ld de,(cxy)
	call crsxy
	call drawk
;increase steps
	ld hl,(steps)
	inc hl
	ld (steps),hl
	call drawscore
	call wincheck
	jp kboard

wincheck:
	ld a,(brd):cp 2:ret nz
	ld a,(brd+2):cp 2:ret nz
	ld a,(brd+6):cp 1:ret nz
	ld a,(brd+8):cp 1:ret nz
 	call beepor
	jr $
markp:
;black or white knights
	ld (sxy),de
;reset value 3
	call r3b
;mark valid moves
;procedure valid_move(x,y,dx,dy:integer);
;		valid_move(x,y,-1,-2);
	ld bc,$FFFE:call validm
;		valid_move(x,y,-2,-1);
	ld bc,$FEFF:call validm
;		valid_move(x,y,1,-2);
	ld bc,$01FE:call validm
;		valid_move(x,y,2,-1);
	ld bc,$02FF:call validm
;		valid_move(x,y,-1,2);
	ld bc,$FF02:call validm
;		valid_move(x,y,-2,1);
	ld bc,$FE01:call validm
;		valid_move(x,y,2,1);
	ld bc,$0201:call validm
;		valid_move(x,y,1,2);
	ld bc,$0102:call validm

	ei:halt
	call drawboard
	ld de,(cxy)
	call crsxy
	jp kboard

validm: ;B.C=dx.dy
	ld de,(cxy)
	ld a,e:add a,b:ld e,a
	jp m, endvm
	cp 3:jr nc,endvm

	ld a,d:add a,c:ld d,a
	jp m, endvm
	cp 3:jr nc,endvm
;check void put 3
	call mapxy
	ld a,(hl)
	or a:jp nz,endvm
	ld (hl),3
;	jr $
endvm:
	ret

; V A R I A B L E S
cxy: dw 0;X.Y
sxy: dw 0; selected knight X.Y
steps:dw 0

drawscore:
	ld hl,(steps)
	ld ix,sbuf
	call DispHL
	
	ld a,5
	ld de,$4003
	ld ix,sbuf
diglp:
	exa
	ld l,(ix+0)
	ld h,0

	add hl,hl;*2
	add hl,hl;*4
	add hl,hl;*8
	add hl,hl;*16
	ld bc,nums
	add hl,bc
	ld b,16
dil:
	ld a,(hl),(de),a
	inc hl
	call nbde
	djnz dil
	inc ix
	exa
	dec a
	jr nz,diglp
	ret
nums:incbin "digits.data"
;Number in hl to decimal ASCII
;Thanks to z80 Bits
;inputs:	hl = number to ASCII
;example: hl=300 outputs '00300'
;destroys: af, bc, hl, de used
DispHL:
	ld	bc,-10000
	call	Num1
	ld	bc,-1000
	call	Num1
	ld	bc,-100
	call	Num1
	ld	c,-10
	call	Num1
	ld	c,-1
Num1:	ld	a,-1;'0'-1
Num2:	inc	a
	add	hl,bc
	jr	c,Num2
	sbc	hl,bc
	;call PUTCHAR
	ld (ix+0),a:inc ix
	ret
sbuf: ds 10
mapxy:;D.E=yx,get adr of board
	ld a,d
	add a,a
	add a,d
	add a,e
	ld hl,brd
	add a,l
	ld l,a
	ld a,h:adc a,0:ld h,a
	ret
r3b:;reset value 3
	ld hl,brd
	ld b,9
re3:
	ld a,(hl)
	cp 1:jr z,r3nxt
	cp 2:jr z,r3nxt
	xor a
r3nxt:
	ld (hl),a
	inc hl
	djnz re3
	ret

wk:;wait keypressed
	xor a
	in a,($fe)
	cpl
	and 31
	jr z,wk
	ret
wp: ;wait until pressed
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wp
	ret

crsxy:;drawcursor
ccol=2*9
	call atr_xy
	dec hl
	push hl
	pop ix
	call clin
	ld a,7
	ld bc,32
cr_2:
	exa
;	ld a,(cc)
	ld (ix+0),ccol;8+1
	ld (ix+7),ccol;8+1
	add ix,bc
	exa
	dec a
	jr nz,cr_2
	push ix
	pop hl
;	ret
clin:
	ld b,8
;	ld a,(cc)
cl_lp:
	ld (hl),ccol;9
	inc hl
	djnz cl_lp
	ret
;cc: db 0

drawk:;draw knights
	ld d,0
	ld ix,brd
dky:
	ld e,0
dkx:
	ld a,(ix+0):inc ix
	ld hl,empty
	or a:jp z,drawsp
;1-black
	dec a:jr nz,whitek
	ld hl,bspr
	ld a,e:xor d:and 1:jr z,bra1
	ld hl,wspr
bra1:
	jp drawsp
whitek:
;2-white
	ld hl,wspr
	ld a,e:xor d:and 1:jr z,drawsp
	ld hl,bspr
drawsp:
	push de
	
	ld a,e
	add a,a
	add a,a
	add a,a
	add a,4+1
	ld e,a
	ld a,d
	add a,a
	add a,a
	add a,a
	add a,$40
	ld d,a
;nx line
	ld a,e
	add a,32
	ld e,a
	ld a,d
	adc a,0
	ld d,a
	call puts
	pop de

	inc e
	ld a,e
	cp 3
	jp nz,dkx

	inc d
	ld a,d
	cp 3
	jp nz,dky
	ret

ib: ;initboard
	call rb
	ld a,1,(brd),a,(brd+2),a;,(brd+1),a
	ld a,2,(brd+6),a,(brd+8),a;,(brd+7),a
	ret
rb: ; resetboard
	ld b,9,hl,brd
rblp:
	ld (hl),0
	inc hl
	djnz rblp
	ret
puts:
;  , HL-, DE-.
	ld a,6*8
ps1:
	exa
	push de
	ldi:ldi:ldi:ldi:ldi:ldi
	pop de
	call nbde
	exa
	dec a
	jr nz,ps1
	ret

nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET

drawboard:
;   +7 x, +3 y
	ld ix,brd
	ld hl,$5800+4;+3*32
	ld d,0
ylp:
	ld e,0
	push hl
xlp:
	push hl
	ld a,e:xor d:and 1
	rra
	sbc a,a
	and %00111000
	jr nz,noblack
	or 7
noblack:
	ld c,8
yy1:
;	ld b,8
	;push hl
xx1:
 dup 8
	ld (hl),a
	inc hl
edup
;	djnz xx1
	;pop hl
	push bc
	ld bc,32-8:add hl,bc
	pop bc
	dec c
	jr nz,yy1
	pop hl
	ld bc,8:add hl,bc
	
;brd?
	ld a,(ix+0):inc ix
	cp 3:jp nz,n_x
;draw green
	push hl
	call atr_xy

	ld bc,32:add hl,bc

	ld c,6
b_y:
	push hl
	ld b,6
b_x:
	ld (hl),4*9
	inc hl
	djnz b_x
	
	pop hl
	push bc
	ld bc,32:add hl,bc
	pop bc
	dec c
	jr nz,b_y

	pop hl
	
n_x:
	inc e
	ld a,e
	cp 3
	jp nz,xlp
	pop hl
	ld bc,8*32:add hl,bc
	inc d
	ld a,d
	cp 3:jp nz,ylp
	ret
atr_xy:
	ld a,e
	add a,a
	add a,a
	add a,a
	add a,4+1
	ld l,a
	ld a,d
	add a,$58
	ld h,a
	ret

bspr:incbin "black.bin"
wspr:incbin "white.bin"
brd:
	db 1,0,1
	db 0,0,0
	db 2,0,2
;+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
; *****************************************************************************
; * Tritone v2 Player (with equal channel volumes)
; *
; * By Shiru (shiru@mail.ru) 03'11
; *
; * Three channels of tone, per-pattern tempo
; * One channel of interrupting drums
; * Feel free to do whatever you want with the code, it is PD
; *
; * Produced by Beepola v1.08.01
; ******************************************************************************

OP_NOP:         EQU   $00                 ; NOP opcode  (used for CHECK_KEMPSTON)
OP_SCF:         EQU   $37                 ; SCF opcode  (used in CHECK_KEMPSTON)
OP_ORC:         EQU   $b1                 ; OR C opcode (used in CHECK_KEMPSTON)

beepor:
                LD    HL,MUSICDATA
                CALL  TRI_PLAY
                RET

TRI_PLAY:
                DI
                LD    (NEXT_POS_POS + 1),HL
                LD    C,16
                PUSH  IY
                EXX
                PUSH  HL
                LD    (PREV_SP+1),SP
                XOR   A
                LD    H,A
                LD    L,H
                LD    (CNT0 + 1),HL
                LD    (CNT1 + 1),HL
                LD    (CNT2 + 1),HL
                LD    (DUTY0 + 1),A
                LD    (DUTY1 + 1),A
                LD    (DUTY2 + 1),A
                LD    (SKIP_DRUM),A
                IN    A,($1F)
                AND   $1F
                LD    A,OP_NOP
                JR    NZ,SET_KEMPSTON
                LD    A,OP_ORC
SET_KEMPSTON:   LD    (CHECK_KEMPSTON),A
                JP    NEXT_POS

NEXT_ROW:
NEXT_ROW_POS:   LD    HL,0
                LD    A,(HL)
                INC   HL
                CP    2
                JR    C,CH0
                CP    128
                JR    C,DRUM_SOUND
                CP    255
                JP    Z,NEXT_POS
CH0:
                LD    D,1
                CP    D
                JR    Z,CH1
                OR    A
                JR    NZ,CH0_NOTE
                LD    B,A
                LD    C,A
                JR    CH0_SET
CH0_NOTE:       LD    E,A
                AND   $0F
                LD    B,A
                LD    C,(HL)
                INC   HL
                LD    A,E
                AND   $F0
CH0_SET:        LD    (DUTY0 + 1),A
                LD    (CNT0 + 1),BC
CH1:
                LD    A,(HL)
                INC   HL
                CP    D
                JR    Z,CH2
                OR    A
                JR    NZ,CH1_NOTE
                LD    B,A
                LD    C,A
                JR    CH1_SET
CH1_NOTE:       LD    E,A
                AND   $0F
                LD    B,A
                LD    C,(HL)
                INC   HL
                LD    A,E
                AND   $F0
CH1_SET:        LD    (DUTY1 + 1),A
                LD    (CNT1 + 1),BC
CH2:
                LD    A,(HL)
                INC   HL
                CP    D
                JR    Z,SKIP
                OR    A
                JR    NZ,CH2_NOTE
                LD    B,A
                LD    C,A
                JR    CH2_SET
CH2_NOTE:       LD    E,A
                AND   $0F
                LD    B,A
                LD    C,(HL)
                INC   HL
                LD    A,E
                AND   $F0
CH2_SET:        LD    (DUTY2 + 1),A
                LD    (CNT2 + 1),BC
SKIP:
                LD    (NEXT_ROW_POS + 1),HL
SKIP_DRUM:      SCF
                JP    NC,PLAY_ROW
                LD    A,OP_NOP
                LD    (SKIP_DRUM),A
                LD    HL,(TEMPO+1)
                LD    DE,65386                 ; DE = -150 
                ADD   HL,DE
                EX    DE,HL
                JR    C,DRM1
                LD    DE,257
DRM1:           LD    A,D
                OR    A
                JR    NZ,DRM2
                INC   D
DRM2:           LD    A,E
                OR    A
                JR    NZ,DRM3
                INC   E
DRM3:           JR    DRUM

DRUM_SOUND:     LD    (NEXT_ROW_POS + 1),HL
                ADD   A,A
                LD    IXL,A
                LD    IXH,0
                LD    BC,DRUM_SETTINGS - 4
                ADD   IX,BC
                CP    28                       ; 14 * 2
                LD    A,OP_SCF
                LD    (SKIP_DRUM),A
                JR    NC,DRUM_NOISE
DRUM_TONE:      LD    BC,2
                LD    A,B
                LD    DE,$1001
                LD    L,(IX+0)
DRUM_TONE_L0:   BIT   0,B
                JR    Z,DRUM_TONE_L1
                DEC   E
                JR    NZ,DRUM_TONE_L1
                LD    E,L
                EX    AF,AF'
                LD    A,L
                ADD   A,(IX + 1)
                LD    L,A
                EX    AF,AF'
                XOR   D
DRUM_TONE_L1:   OUT   ($FE),A
                DJNZ  DRUM_TONE_L0
                DEC   C
                JP    NZ,DRUM_TONE_L0
                JP    NEXT_ROW
DRUM_NOISE:     LD    B,0
                LD    H,B
                LD    L,H
                LD    DE,$1001
DRUM_NOISE_L0:  LD    A,(HL)
                AND   D
                OUT   ($FE),A
                AND   (IX+0)
                DEC   E
                OUT   ($FE),A
                JR    NZ,DRUM_NOISE_L1
                LD    E,(IX+1)
                INC   HL
DRUM_NOISE_L1:  DJNZ  DRUM_NOISE_L0
                JP    NEXT_ROW

NEXT_POS:
NEXT_POS_POS:   LD    HL,0
NEXT_POS_READ:  LD    E,(HL)
                INC   HL
                LD    D,(HL)
                INC   HL
                LD    A,D
                OR    E
                JR    Z,ORDER_LOOP
                LD    (NEXT_POS_POS+1),HL
                EX    DE,HL
                LD    C,(HL)
                INC   HL
                LD    B,(HL)
                INC   HL
                LD    (NEXT_ROW_POS+1),HL
                LD    (TEMPO+1),BC
                JP    NEXT_ROW

ORDER_LOOP:     LD    E,(HL)
                INC   HL
                LD    D,(HL)
                EX    DE,HL
                JR    NEXT_POS_READ

PLAY_ROW:
TEMPO:          LD    DE,0
DRUM:
CNT0:           LD    BC,0
PREV_HL         LD    HL,0
                EXX
CNT1:           LD    DE,0
CNT2:           LD    SP,0
                EXX

SOUND_LOOP:
                ADD   HL,BC            ; 11 Ts
                LD    A,H              ;  4 Ts
                EXX                    ;  4 Ts
DUTY0:          CP    128              ;  7 Ts
                SBC   A,A              ;  4 Ts
                AND   C                ;  4 Ts
                ADD   IX,DE            ; 15 Ts
                OUT   ($FE),A          ; 11 Ts
                LD    A,IXH            ;  8 Ts
DUTY1:          CP    128              ;  7 Ts
                SBC   A,A              ;  4 Ts
                AND   C                ;  4 Ts
                OUT   ($FE),A          ; 11 Ts
                ADD   HL,SP            ; 11 Ts
                LD    A,H              ;  4 Ts
DUTY2:          CP    128              ;  7 Ts
                SBC   A,A              ;  4 Ts
                AND   C                ;  4 Ts
                EXX                    ;  4 Ts
                DEC   E                ;  4 Ts
                OUT   ($FE),A          ; 11 Ts
                JP    NZ,SOUND_LOOP    ; 10 Ts  = 153
                DEC   D                ;  4 Ts
                JP    NZ,SOUND_LOOP    ; 10 Ts
                XOR   A
                OUT   ($FE),A
                LD    (PREV_HL + 1),HL

                IN    A,($1F)
                AND   $1F
                LD    C,A
                XOR   A
                IN    A,($FE)
                CPL
CHECK_KEMPSTON: OR    C            ; This is set to NOP if no kempston i/f detected
                AND   $1F
                ; Change the line below to JP Z,NEXT_ROW to stop music on keypress/joystick
                JP    NEXT_ROW   ; Always jump to next row (ignore keypress/joystick)

STOP_PLAYER:
PREV_SP:        LD    SP,0
                POP   HL
                EXX
                POP   IY
                EI
                RET

DRUM_SETTINGS:
                DEFB  $01,$01     ; 1: Tone, Highest
                DEFB  $01,$02
                DEFB  $01,$04
                DEFB  $01,$08
                DEFB  $01,$20
                DEFB  $20,$04
                DEFB  $40,$04
                DEFB  $40,$08     ; 8: Lowest
                DEFB  $04,$80     ; 9: Special
                DEFB  $08,$80
                DEFB  $10,$80
                DEFB  $10,$02
                DEFB  $20,$02
                DEFB  $40,$02
                DEFB  $16,$01     ; 15: Noise, Highest
                DEFB  $16,$02
                DEFB  $16,$04
                DEFB  $16,$08
                DEFB  $16,$10
                DEFB  $00,$01
                DEFB  $00,$02
                DEFB  $00,$04
                DEFB  $00,$08
                DEFB  $00,$10     ; 24: Last drum

; ************************************************************************
; * Song data...
; ************************************************************************
BORDER_CLR:          EQU $0

; *** DATA ***
MUSICDATA:

; *** Song layout ***
LOOPSTART:            DEFW      PAT0
                      DEFW      PAT1
                      DEFW      PAT2
                      DEFW      PAT3
                      DEFW      PAT4
                      DEFW      PAT5
                      DEFW      PAT6
                      DEFW      PAT7
                      DEFW      $0000
                      DEFW      LOOPSTART

; *** Patterns ***
PAT0:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $06,$86,$F6,$89,$4B,$8B,$B7
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$A5,$01    ,$01
                DEFB      $01    ,$00    ,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$82,$52,$01    ,$EB,$BF
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$84,$A5,$89,$4B,$EC,$68
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $82,$52,$89,$4B,$ED,$ED
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$A5,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$89,$4B,$EC,$68
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$82,$52,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$A5,$89,$4B,$8B,$B7
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$82,$11,$88,$47,$8B,$BB
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$23,$01    ,$AB,$BA
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$86,$F6,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$E2,$19
                DEFB      $00    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$23,$86,$F6,$E8,$47
                DEFB      $01    ,$01    ,$01
                DEFB      $86,$F6,$88,$47,$EC,$68
                DEFB      $01    ,$01    ,$01
                DEFB      $82,$11,$86,$F6,$E8,$47
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$84,$23,$8C,$68,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$82,$11,$88,$47,$EC,$68
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$23,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT1:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $06,$81,$F4,$89,$4B,$8B,$B8
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$E8,$01    ,$01
                DEFB      $01    ,$00    ,$01
                DEFB  $06,$86,$F6,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$F4,$01    ,$01
                DEFB      $01    ,$01    ,$DB,$B9
                DEFB      $01    ,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$83,$E8,$89,$4B,$DC,$68
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$F4,$89,$4B,$DD,$ED
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$E8,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$86,$F6,$DC,$68
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$81,$F4,$01    ,$D9,$4B
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$86,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$E8,$89,$4B,$DB,$B6
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$81,$D8,$89,$4B,$DB,$0D
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$B0,$01    ,$87,$61
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$D8,$01    ,$B3,$ED
                DEFB      $01    ,$01    ,$D3,$B0
                DEFB      $01    ,$01    ,$D3,$EF
                DEFB      $01    ,$01    ,$E3,$B8
                DEFB      $83,$B0,$87,$60,$F9,$54
                DEFB      $01    ,$00    ,$01
                DEFB      $87,$60,$89,$4B,$FB,$0D
                DEFB      $00    ,$00    ,$01
                DEFB      $87,$60,$89,$4B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$F3,$B0
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$81,$D8,$87,$60,$F9,$4B
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$B0,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT2:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $06,$86,$F6,$F9,$57,$FB,$B7
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$A5,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$9B,$BD
                DEFB      $00    ,$01    ,$8B,$BE
                DEFB  $03,$82,$52,$00    ,$9B,$BB
                DEFB      $01    ,$01    ,$AB,$C2
                DEFB      $01    ,$F6,$F6,$BB,$C7
                DEFB      $01    ,$01    ,$00
                DEFB  $06,$84,$A5,$F9,$4B,$8B,$B7
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$F6,$F6,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $05,$82,$52,$F9,$4B,$8D,$ED
                DEFB      $84,$A5,$01    ,$01
                DEFB      $82,$52,$01    ,$01
                DEFB      $81,$29,$99,$6C,$01
                DEFB      $84,$A5,$00    ,$01
                DEFB      $80,$94,$99,$56,$01
                DEFB  $06,$86,$F6,$89,$4C,$9C,$68
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$82,$52,$00    ,$01
                DEFB      $01    ,$89,$4B,$CC,$73
                DEFB      $01    ,$84,$A5,$9C,$7E
                DEFB      $01    ,$82,$52,$9C,$89
                DEFB      $84,$A5,$86,$F6,$9B,$B6
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$8A,$6E,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$82,$11,$8C,$68,$90,$20
                DEFB      $01    ,$01    ,$C0,$19
                DEFB      $01    ,$01    ,$A0,$20
                DEFB      $01    ,$01    ,$00
                DEFB      $84,$23,$01    ,$D0,$20
                DEFB      $01    ,$01    ,$80,$20
                DEFB  $06,$01    ,$8C,$68,$E0,$20
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$82,$11,$8C,$68,$88,$47
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$00    ,$00
                DEFB      $01    ,$BC,$7E,$B8,$89
                DEFB      $84,$23,$CA,$6E,$CC,$68
                DEFB      $01    ,$01    ,$01
                DEFB      $88,$47,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $82,$11,$01    ,$01
                DEFB      $86,$F6,$01    ,$01
                DEFB      $88,$47,$CA,$6E,$01
                DEFB      $89,$4B,$01    ,$01
                DEFB  $06,$84,$23,$CC,$68,$CF,$A1
                DEFB      $89,$4B,$01    ,$01
                DEFB      $88,$47,$01    ,$01
                DEFB      $86,$F6,$01    ,$01
                DEFB  $03,$82,$11,$01    ,$01
                DEFB      $86,$F6,$01    ,$01
                DEFB  $06,$8A,$6E,$CC,$68,$CD,$ED
                DEFB      $01    ,$01    ,$01
                DEFB      $84,$23,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT3:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $06,$87,$D0,$89,$D9,$DB,$B7
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$E8,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB  $03,$81,$F4,$99,$DC,$01
                DEFB      $01    ,$00    ,$01
                DEFB      $01    ,$B9,$E0,$01
                DEFB      $01    ,$00    ,$01
                DEFB  $06,$83,$E8,$89,$DD,$01
                DEFB      $01    ,$00    ,$01
                DEFB      $01    ,$E9,$DD,$01
                DEFB      $01    ,$00    ,$01
                DEFB      $81,$F4,$89,$DE,$01
                DEFB      $01    ,$00    ,$01
                DEFB      $01    ,$E9,$D9,$01
                DEFB      $01    ,$00    ,$01
                DEFB      $83,$E8,$A9,$D9,$01
                DEFB      $01    ,$C9,$E4,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$81,$F4,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$E8,$01    ,$01
                DEFB      $01    ,$00    ,$01
                DEFB      $01    ,$C9,$D9,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$81,$F4,$C9,$D9,$DB,$B7
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$00    ,$00
                DEFB      $83,$E8,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB      $87,$D0,$C7,$D0,$87,$D5
                DEFB  $03,$81,$F4,$C9,$D9,$9B,$B9
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$C1,$F4,$00
                DEFB      $01    ,$01    ,$CB,$BB
                DEFB  $05,$83,$E8,$89,$DA,$DC,$75
                DEFB  $04,$01    ,$01    ,$01
                DEFB  $03,$01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB  $07,$81,$F4,$A9,$E1,$01
                DEFB  $08,$01    ,$01    ,$CC,$8B
                DEFB  $08,$01    ,$01    ,$00
                DEFB  $08,$01    ,$01    ,$01
                DEFB  $08,$83,$E8,$C9,$D9,$CD,$FA
                DEFB  $05,$01    ,$01    ,$01
                DEFB  $06,$01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$81,$F4,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$E8,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT4:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$8E,$8F,$A2,$89,$4C
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$1A,$01    ,$8C,$69
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$8D,$89,$4B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$1A,$8F,$A1,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$8D,$8C,$68,$8C,$68
                DEFB      $01    ,$01    ,$00
                DEFB      $81,$F4,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $04,$83,$1A,$89,$4B,$89,$4B
                DEFB      $01    ,$01    ,$00
                DEFB      $89,$4B,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$8D,$8F,$A1,$F4,$A9
                DEFB      $01    ,$00    ,$01
                DEFB      $00    ,$8F,$A1,$F4,$AD
                DEFB      $01    ,$01    ,$B9,$4F
                DEFB  $04,$83,$1A,$01    ,$F4,$A7
                DEFB      $01    ,$8F,$EE,$00
                DEFB      $01    ,$00    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$88,$C6,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$7B,$8D,$ED,$F6,$F6
                DEFB      $01    ,$01    ,$F3,$7B
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$8A,$6E,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $8D,$ED,$88,$C6,$F3,$7B
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$86,$F6,$FD,$ED
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $04,$83,$7B,$8A,$6E,$F1,$BD
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$88,$C6,$80,$20
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $04,$83,$7B,$8D,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT5:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $81,$8D,$89,$4B,$89,$CA
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$1A,$01    ,$8B,$B6
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$8D,$8C,$68,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$1A,$8F,$A1,$88,$C6
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$8D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$88,$CC
                DEFB      $01    ,$01    ,$98,$F2
                DEFB  $04,$83,$1A,$01    ,$A8,$CC
                DEFB      $01    ,$01    ,$B8,$E7
                DEFB      $01    ,$01    ,$C8,$CD
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$8D,$89,$4B,$CF,$A1
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $04,$83,$1A,$8F,$A1,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $81,$BD,$88,$C6,$B0,$20
                DEFB      $01    ,$01    ,$00
                DEFB      $81,$BD,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$7B,$01    ,$BB,$B6
                DEFB      $00    ,$01    ,$01
                DEFB      $83,$7B,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB  $03,$81,$BD,$01    ,$BC,$68
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $83,$7B,$8D,$ED,$00
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$B6,$F6
                DEFB      $01    ,$01    ,$00
                DEFB      $81,$BD,$8E,$03,$AC,$68
                DEFB      $01    ,$9E,$19,$AA,$83
                DEFB      $01    ,$AE,$03,$BC,$73
                DEFB      $01    ,$BE,$3A,$B5,$4D
                DEFB  $04,$83,$7B,$BA,$6E,$A7,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$01    ,$97,$01
                DEFB  $04,$81,$BD,$BD,$ED,$93,$7B
                DEFB      $00    ,$01    ,$00
                DEFB  $02,$81,$BD,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $83,$7B,$BD,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT6:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB  $03,$81,$8D,$89,$4B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$F3,$1A,$01
                DEFB      $83,$1A,$C4,$A5,$8B,$B6
                DEFB      $01    ,$01    ,$01
                DEFB  $02,$01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB  $03,$81,$8D,$8C,$68,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $83,$1A,$8F,$A1,$89,$4B
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $81,$8D,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$00    ,$01
                DEFB  $03,$83,$1A,$01    ,$00
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $81,$8D,$89,$4B,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB  $03,$83,$1A,$8F,$A1,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $81,$BD,$88,$C6,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$F3,$7B,$01
                DEFB      $93,$7B,$D5,$37,$8B,$B6
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $91,$BD,$00    ,$8C,$68
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $A3,$7B,$8D,$ED,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$8E,$24,$00
                DEFB      $A1,$BD,$01    ,$01
                DEFB      $00    ,$00    ,$01
                DEFB      $B1,$BD,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $B3,$7B,$8A,$6E,$8A,$8F
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $B1,$BD,$8D,$ED,$8E,$0E
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB      $B3,$7B,$88,$C6,$88,$E7
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$01    ,$01
                DEFB  $FF  ; End of Pattern

PAT7:
                DEFW  1850     ; Pattern tempo
                ;    Drum,Chan.1 ,Chan.2 ,Chan.3
                DEFB      $91,$F4,$8F,$A1,$8F,$C2
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$00
                DEFB      $A3,$E8,$01    ,$8B,$B6
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$9B,$B6
                DEFB      $91,$F4,$89,$4B,$01
                DEFB      $01    ,$01    ,$FB,$B6
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $A3,$E8,$88,$C6,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $91,$F4,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $B3,$E8,$01    ,$89,$4C
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$A1,$F4,$87,$D0,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $03,$B3,$E8,$01    ,$01
                DEFB      $01    ,$01    ,$F9,$77
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$01    ,$D9,$77
                DEFB  $03,$A1,$F4,$B8,$12,$00
                DEFB      $01    ,$B7,$D6,$B9,$77
                DEFB      $01    ,$A8,$12,$00
                DEFB      $01    ,$B7,$D6,$99,$77
                DEFB  $03,$C3,$E8,$98,$12,$00
                DEFB      $01    ,$97,$D6,$A9,$77
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$C7,$D6,$A9,$77
                DEFB  $03,$B1,$F4,$01    ,$00
                DEFB      $01    ,$A7,$D7,$C9,$51
                DEFB      $01    ,$98,$1D,$00
                DEFB      $01    ,$01    ,$E9,$51
                DEFB  $03,$C3,$E8,$01    ,$00
                DEFB      $01    ,$C7,$D8,$E9,$50
                DEFB      $01    ,$C8,$28,$00
                DEFB      $01    ,$01    ,$C9,$4F
                DEFB  $06,$B1,$F4,$01    ,$00
                DEFB      $01    ,$C7,$D9,$A9,$4E
                DEFB      $01    ,$01    ,$00
                DEFB      $01    ,$01    ,$99,$4E
                DEFB  $06,$C3,$E8,$A8,$33,$00
                DEFB      $01    ,$01    ,$99,$4D
                DEFB      $01    ,$A8,$33,$00
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$B1,$F4,$A3,$E8,$97,$D0
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB      $01    ,$01    ,$01
                DEFB  $06,$C3,$E8,$A7,$D0,$9F,$A1
                DEFB      $01    ,$01    ,$01
                DEFB      $00    ,$00    ,$00
                DEFB      $01    ,$01    ,$01
                DEFB  $FF  ; End of Pattern
;+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+
end
	display /d,end-begin
	savesna "!fk.sna",begin
	savebin "4k.code",begin,end-begin
